///// external defines of memory expander
///// only accessptr() used by renderer
///// most in rend386.h too

// MAP-EMM systemm, Copyright 26/12/93 by Dave Stampe

/*
 This code is part of the VR-386 project, created by Dave Stampe.
 VR-386 is a desendent of REND386, created by Dave Stampe and
 Bernie Roehl.  Almost all the code has been rewritten by Dave
 Stampre for VR-386.

 Copyright (c) 1994 by Dave Stampe:
 May be freely used to write software for release into the public domain
 or for educational use; all commercial endeavours MUST contact Dave Stampe
 (dstampe@psych.toronto.edu) for permission to incorporate any part of
 this software or source code into their products!  Usually there is no
 charge for under 50-100 items for low-cost or shareware products, and terms
 are reasonable.  Any royalties are used for development, so equipment is
 often acceptable payment.

 ATTRIBUTION:  If you use any part of this source code or the libraries
 in your projects, you must give attribution to VR-386 and Dave Stampe,
 and any other authors in your documentation, source code, and at startup
 of your program.  Let's keep the freeware ball rolling!

 DEVELOPMENT: VR-386 is a effort to develop the process started by
 REND386, improving programmer access by rewriting the code and supplying
 a standard API.  If you write improvements, add new functions rather
 than rewriting current functions.  This will make it possible to
 include you improved code in the next API release.  YOU can help advance
 VR-386.  Comments on the API are welcome.

 CONTACT: dstampe@psych.toronto.edu
*/




extern int EMM_active;		// set if EMM is turned on

extern long alloccount;	   // counts successful calls to extmalloc <DEBUG>

int initEMMalloc(long wanted);	// inits system arg is desired pages
				// returns actual pages available

void resetEMMalloc();       // release EMM memory

void *extmalloc(long n);    // use this in programs

void extfree(void *p);  // free ext. mem

void restoreEMM();      // call this if you screw around with EMM mapping

int accessptr(void *p); // check that pointer's data is mapped in

long EMMheapsize();	// EMM left

long EMMheapused();	// EMM used so far

