;----------------------------------------------------------------------------:
; SILVERMOON																 :
;																			 :
; Globals				   (C) John Connors 1993							 :
;----------------------------------------------------------------------------:

;----------------------------------------------------------------------------:
;			DATA SEGMENT													 :
;----------------------------------------------------------------------------:


SEGMENT Data_Segment DWORD PUBLIC USE32 'DATA'
ENDS	Data_Segment

;----------------------------------------------------------------------------:
;			CODE SEGMENT													 :
;----------------------------------------------------------------------------:


SEGMENT Code_Segment DWORD PUBLIC USE16 'CODE'
ENDS	Code_Segment

;----------------------------------------------------------------------------:
;			VIDEO SEGMENT										 :
;----------------------------------------------------------------------------:

SEGMENT Video_Segment AT 0a000h
ENDS	Video_Segment

;----------------------------------------------------------------------------:
; Mouse Globals 															 :
;----------------------------------------------------------------------------:
	GLOBAL	Install_Mouse:FAR,UnInstall_Mouse:FAR
	    
;----------------------------------------------------------------------------:
; VGA Globals																 :
;----------------------------------------------------------------------------:

	GLOBAL	Test_Card:NEAR,Unchain:NEAR,Set_VGA_Colour:NEAR
	GLOBAL	Enable_VGA_Bit_Plane:NEAR,Copy_Screen_to_VGA:NEAR

;----------------------------------------------------------------------------:
; Memory Management Globals 												 :
;----------------------------------------------------------------------------:

	GLOBAL	Malloc:NEAR,Free:NEAR
    
;----------------------------------------------------------------------------:
; file globals																 :
;----------------------------------------------------------------------------:

	GLOBAL Get_File:NEAR,File_Data:BYTE:0fff0h,File_Name_List:WORD

;----------------------------------------------------------------------------:
; PCX decoding globals														 :
;----------------------------------------------------------------------------:

	GLOBAL Set_PCX_Palette:NEAR,Decode_PCX_Screen:NEAR

;----------------------------------------------------------------------------:
; Fatal error globals														 :
;----------------------------------------------------------------------------:

	GLOBAL Fuckup:FAR

;----------------------------------------------------------------------------:
; Sprite Globals															 :
;----------------------------------------------------------------------------:

	GLOBAL	Display_Unclipped_Sprite:NEAR,Erase_Unclipped_Sprite:NEAR
	GLOBAL	Display_Clipped_Sprite:NEAR,Display_Wrapped_Sprite:NEAR
	GLOBAL	Save_Unclipped_Background:NEAR,Display_Unclipped_Block:NEAR
	GLOBAL	Limit_Sprite:NEAR
	GLOBAL	Set_Up_Frame:NEAR,Separate_Sprite_Planes:NEAR
	GLOBAL	Separate_Mask_Planes:NEAR
	GLOBAL	Set_Up_Sprite:NEAR,Reset_Sprite_Data:NEAR
	GLOBAL	Image_Buffer:BYTE:64000
	GLOBAL	Display_Wrapped_Mask:NEAR
    
Sprite_Item_Size = 32
Frame_Item_Size  = 16
    
;----------------------------------------------------------------------------:
; VBlank Globals															 :
;----------------------------------------------------------------------------:

	GLOBAL	VBlank_Service:FAR
	GLOBAL	Screen_Buffer:BYTE:64000

;----------------------------------------------------------------------------:
; Scroll Globals															 :
;----------------------------------------------------------------------------:

	GLOBAL	Scroll_Left:NEAR,Scroll_Right:NEAR

;----------------------------------------------------------------------------:
;Boggle Globals 															 :
;----------------------------------------------------------------------------:

	GLOBAL Update_Boggle:NEAR
	 
;----------------------------------------------------------------------------:
;Broderick Globals															 :
;----------------------------------------------------------------------------:

	GLOBAL Update_Broderick:NEAR
    
;----------------------------------------------------------------------------:
; Sword Globals 															 :
;----------------------------------------------------------------------------:

	GLOBAL Update_Sword:NEAR

	GLOBAL Update_Candle:NEAR
    
;----------------------------------------------------------------------------:
; Keyboard Globlas															 :
;----------------------------------------------------------------------------:

	GLOBAL Check_Keyboard:NEAR,Set_Up_Keyboard:NEAR,Reset_Keyboard:FAR

;----------------------------------------------------------------------------:
; Sprite Numbers															 :
;----------------------------------------------------------------------------:

Boggle_Body_Sprite		EQU 0
Boggle_Head_Sprite		EQU 1
Broderick_Body_Sprite	EQU 2
Broderick_Head_Sprite	EQU 3
Potion_Sprite			EQU 4
Boggle_Score_Sprite 	EQU 5
Broderick_Score_Sprite	EQU 6
Flame_Bar_Sprite		EQU 7
Name_Box_Sprite 		EQU 8
Count_Box_Sprite		EQU 9
Boggle_Bar_Sprite		EQU 10
Broderick_Bar_Sprite	EQU 11
Boggle_Life_Sprite		EQU 12
Broderick_Life_Sprite	EQU 13
Sword_Sprite			EQU 14
Candle_Sprite			EQU 15
Candle_Mask_Sprite		EQU 16

;----------------------------------------------------------------------------:
; Screen Layout 															 :
;----------------------------------------------------------------------------:

Potion_X_Position	EQU 111
Potion_Y_Position	EQU 1

Boggle_Score_X_Position EQU 2
Boggle_Score_Y_Position EQU 1

Broderick_Score_X_Position EQU 227
Broderick_Score_Y_Position EQU 1

Flame_Bar_X_Position EQU 1
Flame_Bar_Y_Position EQU 27

Name_Box_X_Position EQU 161
Name_Box_Y_Position EQU 1

Count_Box_X_Position EQU 161
Count_Box_Y_Position EQU 14

Boggle_Bar_X_Position EQU 30
Boggle_Bar_Y_Position EQU 1

Broderick_Bar_X_Position EQU 255
Broderick_Bar_Y_Position EQU 1

Boggle_Life_X_Position EQU 95
Boggle_Life_Y_Position EQU 1

Broderick_Life_X_Position EQU 213
Broderick_Life_Y_Position EQU 1


; coords of first appearance
 
Boggle_Inital_X 	EQU 140
Boggle_Inital_Y 	EQU 90

Broderick_Inital_X EQU 140
Broderick_Inital_Y EQU 102

Candle_Inital_X    EQU 124
Candle_Inital_Y    EQU 111

Candle_Mask_Inital_X EQU 118
Candle_Mask_Inital_Y EQU 93

; offset of boggle's head from his body! (tweak to avoid headless dragons)

Boggle_Head_X_Offset EQU 36
Boggle_Head_Y_Offset EQU 12

;----------------------------------------------------------------------------:
; Symbols for frames of animation											 :
;----------------------------------------------------------------------------:

Maximum_Sprites = 32
Maximum_Frames = 100
Maximum_Files = Maximum_Frames

Background_Test_File EQU 0
Boggle_Start_File	 EQU 1

Stop_Potion_File	 EQU 6
Boggle_Score_File	 EQU 7
Broderick_Score_File EQU 8
Flame_Bar_File		 EQU 9
Name_Box_File		 EQU 10
Count_Box_File		 EQU 11
Boggle_Bar_File 	 EQU 12
Broderick_Bar_File	 EQU 13
Boggle_Life_File	 EQU 14
Broderick_Life_File  EQU 15

Boggle_Frames		 EQU 5
Stop_Potion_Frame	 EQU 6
Flame_Bar_Frame 	 EQU 9
Name_Box_Frame		 EQU 10
Count_Box_Frame 	 EQU 11
Boggle_Bar_Frame	 EQU 12
Broderick_Bar_Frame  EQU 13
Boggle_Life_Frame	 EQU 14
Broderick_Life_Frame EQU 15
Boggle_Head_Frame	 EQU 16
Boggle_Head_Frames	 EQU 10 					; includes smoking and flaming
Boggle_Smoke_Frame	 EQU 17
Boggle_Smoke_Frames  EQU 3
Boggle_Flame_Frame	 EQU 21
Boggle_Flame_Frames  EQU 6
Broderick_Walk_Frame EQU 56
Broderick_Walk_Frames	EQU 8
Sword_Walk_Frame	EQU 70
Sword_Walk_Frames	EQU 8
Sword_Melt_Frame	EQU 80
Sword_Melt_Frames	EQU 7
Candle_Frame		EQU 90
Candle_Mask_Frame	EQU 91

;----------------------------------------------------------------------------:
; States of player sprites													 :
;----------------------------------------------------------------------------:

; broderick states

Broderick_Walking			EQU 1
Broderick_Ducking			EQU 2
Broderick_Turning			EQU 4
Broderick_Falling_Left		EQU 8
Broderick_Catching_Left 	EQU 16
Broderick_Falling_Right 	EQU 32
Broderick_Catching_Right	EQU 64

; boggle's state

Boggle_Cruising 	 EQU 0						; just flyin' along
Boggle_At_Left_Edge  EQU 1
Boggle_At_Right_Edge EQU 2
Boggle_Smoking		 EQU 4
Boggle_Flaming_Left  EQU 8
Boggle_Flaming_Right EQU 16
Boggle_Turning		 EQU 32
Boggle_Exploding	 EQU 64 				; oh, dear - hydrogen
Boggle_Loaded		 EQU 128				; boggie has sommat in claws

; sword state

Sword_Non_Existent EQU 0
Sword_Walking	   EQU 1
Sword_Melting	   EQU 2
Sword_Dead		   EQU 4
Sword_Dying 	   EQU 8
Sword_Erasing	   EQU 16

; candle states

Candle_Non_Existant EQU 0
Candle_On			EQU 1
Candle_Off			EQU 2
Candle_Dying		EQU 4
	    
;----------------------------------------------------------------------------:
;	Error numbers															 :
;----------------------------------------------------------------------------:

File_Fuckup 		EQU 0
Image_Space_Fuckup	EQU 1

;----------------------------------------------------------------------------:
; Key scan stuff															 :
;----------------------------------------------------------------------------:

Flip_Boggle_Scan_Code	EQU 0fh 				; tab key

